%% ../lib/ffi/include/i586-alt-linux-gnu/ffi_hardcodes.hrl.  Generated from ffi_hardcodes.hrl.in by configure.

%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved via the world wide web at http://www.erlang.org/.
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Initial Developer of the Original Code is CRS4 - Center for
%% Advanced Studies, Research and Development in Sardinia
%% (http://www.crs4.it/). All Rights Reserved.''
%% 
%%     $Id$

%% Foreign Function Interface (FFI) for Erlang/OTP
%% Copyright (C) 2007 by CRS4 - http://www.crs4.it/
%% Author: Alceste Scalas <alceste@crs4.it>

-ifndef(__FFI_HARDCODES_HRL__).
-define(__FFI_HARDCODES_HRL__, 1).

%%
%% Hardcoded type sizes for FFI types.  If you decide to use them, you
%% may need to recompile your BEAM files in order to make them run on
%% different platforms.
%%
-define(FFI_HARDCODED_SIZEOF_UCHAR, 1).
-define(FFI_HARDCODED_UCHAR_BITS, 8).
-define(FFI_HARDCODED_SIZEOF_SCHAR, 1).
-define(FFI_HARDCODED_SCHAR_BITS, 8).

-define(FFI_HARDCODED_SIZEOF_USHORT, 2).
-define(FFI_HARDCODED_USHORT_BITS, 16).
-define(FFI_HARDCODED_SIZEOF_SSHORT, 2).
-define(FFI_HARDCODED_SSHORT_BITS, 16).

-define(FFI_HARDCODED_SIZEOF_UINT, 4).
-define(FFI_HARDCODED_UINT_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_SINT, 4).
-define(FFI_HARDCODED_SINT_BITS, 32).

-define(FFI_HARDCODED_SIZEOF_ULONG, 4).
-define(FFI_HARDCODED_ULONG_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_SLONG, 4).
-define(FFI_HARDCODED_SLONG_BITS, 32).

-define(FFI_HARDCODED_SIZEOF_UINT8, 1).
-define(FFI_HARDCODED_UINT8_BITS, 8).
-define(FFI_HARDCODED_SIZEOF_SINT8, 1).
-define(FFI_HARDCODED_SINT8_BITS, 8).

-define(FFI_HARDCODED_SIZEOF_UINT16, 2).
-define(FFI_HARDCODED_UINT16_BITS, 16).
-define(FFI_HARDCODED_SIZEOF_SINT16, 2).
-define(FFI_HARDCODED_SINT16_BITS, 16).

-define(FFI_HARDCODED_SIZEOF_UINT32, 4).
-define(FFI_HARDCODED_UINT32_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_SINT32, 4).
-define(FFI_HARDCODED_SINT32_BITS, 32).

-define(FFI_HARDCODED_SIZEOF_UINT64, 8).
-define(FFI_HARDCODED_UINT64_BITS, 64).
-define(FFI_HARDCODED_SIZEOF_SINT64, 8).
-define(FFI_HARDCODED_SINT64_BITS, 64).

-define(FFI_HARDCODED_SIZEOF_FLOAT, 4).
-define(FFI_HARDCODED_FLOAT_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_DOUBLE, 8).
-define(FFI_HARDCODED_DOUBLE_BITS, 64).
-define(FFI_HARDCODED_SIZEOF_LONG_DOUBLE, 12).
-define(FFI_HARDCODED_LONG_DOUBLE_BITS, 96).

-define(FFI_HARDCODED_SIZEOF_POINTER, 4).
-define(FFI_HARDCODED_POINTER_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_CSTRING, 4).
-define(FFI_HARDCODED_CSTRING_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_NONNULL, 4).
-define(FFI_HARDCODED_NONNULL_BITS, 32).

-define(FFI_HARDCODED_SIZEOF_SIZE_T, 4).
-define(FFI_HARDCODED_SIZE_T_BITS, 32).
-define(FFI_HARDCODED_SIZEOF_SSIZE_T, 4).
-define(FFI_HARDCODED_SSIZE_T_BITS, 32).

-define(FFI_HARDCODED_SIZEOF_OFF_T, 8).
-define(FFI_HARDCODED_OFF_T_BITS, 64).

-define(FFI_HARDCODED_SIZEOF_PID_T, 4).
-define(FFI_HARDCODED_PID_T_BITS, 32).

%%
%% Hardcoded bit syntax macros for FFI types.  If you decide to use
%% them, you may need to recompile your BEAM files in order to make
%% them run on different platforms.
%%
-define(FFI_HARDCODED_UCHAR,
        ?FFI_HARDCODED_UCHAR_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SCHAR,
        ?FFI_HARDCODED_SCHAR_BITS/native-signed-integer).

-define(FFI_HARDCODED_USHORT,
        ?FFI_HARDCODED_USHORT_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SSHORT,
        ?FFI_HARDCODED_SSHORT_BITS/native-signed-integer).

-define(FFI_HARDCODED_UINT,
        ?FFI_HARDCODED_UINT_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SINT,
        ?FFI_HARDCODED_SINT_BITS/native-signed-integer).

-define(FFI_HARDCODED_ULONG,
        ?FFI_HARDCODED_ULONG_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SLONG,
        ?FFI_HARDCODED_SLONG_BITS/native-signed-integer).

-define(FFI_HARDCODED_UINT8,
        ?FFI_HARDCODED_UINT8_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SINT8,
        ?FFI_HARDCODED_SINT8_BITS/native-signed-integer).

-define(FFI_HARDCODED_UINT16,
        ?FFI_HARDCODED_UINT16_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SINT16,
        ?FFI_HARDCODED_SINT16_BITS/native-signed-integer).

-define(FFI_HARDCODED_UINT32,
        ?FFI_HARDCODED_UINT32_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SINT32,
        ?FFI_HARDCODED_SINT32_BITS/native-signed-integer).

-define(FFI_HARDCODED_UINT64,
        ?FFI_HARDCODED_UINT64_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SINT64,
        ?FFI_HARDCODED_SINT64_BITS/native-signed-integer).

-define(FFI_HARDCODED_FLOAT,
        ?FFI_HARDCODED_FLOAT_BITS/native-float).
-define(FFI_HARDCODED_DOUBLE,
        ?FFI_HARDCODED_DOUBLE_BITS/native-float).

%% Sorry, no long double support
%%-define(FFI_HARDCODED_LONG_DOUBLE,     
%%        ?FFI_HARDCODED_LONG_DOUBLE_BITS/native-signed-integer).

-define(FFI_HARDCODED_POINTER,
        ?FFI_HARDCODED_POINTER_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_CSTRING,
        ?FFI_HARDCODED_CSTRING_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_NONNULL,
        ?FFI_HARDCODED_NONNULL_BITS/native-unsigned-integer).

-define(FFI_HARDCODED_SIZE_T,
        ?FFI_HARDCODED_SIZE_T_BITS/native-unsigned-integer).
-define(FFI_HARDCODED_SSIZE_T,
        ?FFI_HARDCODED_SSIZE_T_BITS/native-signed-integer).

-define(FFI_HARDCODED_OFF_T,
        ?FFI_HARDCODED_OFF_T_BITS/native-signed-integer).

-define(FFI_HARDCODED_PID_T,
        ?FFI_HARDCODED_PID_T_BITS/native-signed-integer).

-endif. % __FFI_HARDCODES_HRL__
